autowatch = 1;
outlets = 2;
setoutletassist(0,"IDs");
setoutletassist(1,"labels");

var name;
var thechain = 0;
var enable = 0;
var this_device;
var track_id;
var finder;
var devices;
var target_id;
var chains_count;
var parameter_count;
var nametoid = new Object();
var LiveClassNames = ['InstrumentGroupDevice', 'DrumGroupDevice', 'Operator', 
'UltraAnalog', 'OriginalSimpler', 'MultiSampler', 'LoungeLizard', 'StringStudio', 
'Collision', 'InstrumentImpulse'];
var Devices = new Object();

//in order: to populate A,D,S,R and Pitch, Filter encoders. Vol and Pan are handled by chain mixer.
//for Groups/Racks, the knobs just map to the macros
//these were "discovered" by using the "bang" function to get all parameters, then manually finding the ones I want. Boring!
//see bottom: Appendix 01
var Params = new Object();

function loadbang(){
    post("\nParam Init");
    for(i in LiveClassNames){
        Params[LiveClassNames[i]] =new Object();
    }
    Params["InstrumentGroupDevice"].nos = [1,2,3,4, 5,6];
    Params["DrumGroupDevice"].nos = [1,2,3,4, 5,6];
    Params["Operator"].nos = [20,47,74,101, 2,167];
    Params["UltraAnalog"].nos = [80,81,83,85, 32,48];
    Params["OriginalSimpler"].nos = [26,27,28,29, 11,32];
    Params["MultiSampler"].nos = [59,62,65,66, 34,74];
    Params["LoungeLizard"].nos = [10,17,22,23, 4,25];
    Params["StringStudio"].nos = [24,34,37,40, 4,76];
    Params["Collision"].nos = [27,28,29,30, 34,51];
    Params["InstrumentImpulse"].nos = [4,18,9,2, 3,13];
    
    Params["InstrumentGroupDevice"].names = [0,0,0,0,0,0,"Pan","Vol"];//use macro names
    Params["DrumGroupDevice"].names = [0,0,0,0,0,0,"Pan","Vol"];//use macro names
    Params["Operator"].names = ["OscA","OscB","OscC","OscD","Pitch","Filter","Pan","Vol"];
    Params["UltraAnalog"].names = ["A","D","S","R","Pitch","Filter","Pan","Vol"];
    Params["OriginalSimpler"].names = ["A","D","S","R","Pitch","Filter","Pan","Vol"];
    Params["MultiSampler"].names = ["A","D","S","R","Pitch","Filter","Pan","Vol"];
    Params["LoungeLizard"].names = ["Force","Release","TDecay","TVol","Pitch","Dist","Pan","Vol"];
    Params["StringStudio"].names = ["Pos","Force","Frict","Veloc","Pitch","Freq","Pan","Vol"];
    Params["Collision"].names = ["A","D","S","R","RTune","RBright","Pan","Vol"];
    Params["InstrumentImpulse"].names = ["Start","EDecay","Stretch","Time","Pitch","Filter","Pan","Vol"];
}
function msg_int(v){
    thechain = v;
    if(enable){
        chain(v);
    }
}

function init(){
    enable = 1;
    chain(thechain);    
}

function chain(v)
{
    this_device = new LiveAPI('this_device');
    this_device.goto('canonical_parent');
    track_id = parseInt(this_device.id);
    finder = new LiveAPI('live_set');
    finder.id = track_id;
    devices = finder.getcount('devices');
    target_id = 0;
    //go to the device in the track:
    finder.goto('devices', 1);
    var devicename = finder.get('class_name');
    //post("\nSelected Device -->",devicename);
    target_id = parseInt(finder.id);
    finder.id = target_id;
    //go to the selected chain:
    finder.goto('chains', v);
    var chains_id = parseInt(finder.id);
    //find out what kind of device is in that chain:
    finder.goto("devices", 0);
    var dev_id = parseInt(finder.id);
    var devname = finder.get('class_name');
    post("\nDevice : ",devname,"chain",v,"devid",dev_id);
    //get the parameters we want to link to in that device:
    var theids = new Array();
    for(i in Params[devname].nos){
        //go to the parameter indices we setup in loadbang():
        finder.goto("parameters", Params[devname].nos[i]);    
        //get the object ID:
        var id = parseInt(finder.id);
        //post("\ngoto", Params[devname].nos[i],"id",id);    
        var label;
        //get the official parameter name:
        var pname = finder.get('name');
        //post("\npname",pname);
        //get the label for the knob that we setup in loadbang()
        var mylabel = Params[devname].names[i];
        if(mylabel){
            label = mylabel;
        }else{
            label = pname; //for groups and racks
        }
        outlet(1,"script","send","l["+i+"]","set",label);
        outlet(0,parseInt(i),"id",id); //for live.object
        //post("\nparams",i,id,pname,label);    
        finder.id = dev_id;;//reset path
    }
}


function bang()
{
    this_device = new LiveAPI('this_device');
    this_device.goto('canonical_parent');
    track_id = parseInt(this_device.id);
    finder = new LiveAPI('live_set');
    finder.id = track_id;
    devices = finder.getcount('devices');
    target_id = 0;
    for(var i=0;i<devices;i++)
    {
        finder.goto('devices', i);
        var devicename = finder.get('class_name');
        post("\n * 00-DeviceName",devicename);
        if(devicename=='DrumGroupDevice')
        {
            target_id = parseInt(finder.id);
        }
        finder.id = track_id;
    }
    if(target_id != 0)
    {
        finder.id = target_id;
        chains_count = parseInt(finder.getcount('chains'));
        post("\n * 01-Chains",chains_count);
        for(var j=0;j<chains_count;j++)
        {
            finder.goto('chains', j);
            var chains_id = parseInt(finder.id);
            post("\n *------* CHAIN *------*",j,"of",chains_count);
            var dev_count = finder.getcount('devices');
            if(dev_count>0)
            {                
                for(var k=0;k<dev_count;k++)
                {
                    finder.goto("devices", k);
                    var devname = finder.get('class_name');
                    post("\nDevice : ",devname);
                    Devices[devname]= new Object();
                    var devices_id = parseInt(finder.id);
                    parameter_count = parseInt(finder.getcount('parameters'));
                    
                    for(var l=0;l<parameter_count;l++)
                    {
                        finder.goto("parameters", l);
                        var pname = finder.get('name');
                        Devices[devname][l]=pname;
                        post("\n",l,pname);
                        //var parameters_id = finder.id;
                        finder.id = devices_id;
                    }
                    
                    /*
                    if((finder.get('can_have_chains')!=0)&&(finder.getcount('chains')>0))
                    {
                        for (var m=0;m<finder.getcount('chains');m++)
                        {
                            post("\n +---------- SubChain -------+",m)
                            finder.goto('chains', m);
                            var deep_chains_id = parseInt(finder.id);
                            if(finder.getcount('devices')>0)
                            {
                                for(var n=0;n<finder.getcount('devices');n++)
                                {
                                    finder.goto("devices", n);
                                    var deep_devices_id = parseInt(finder.id);
                                    parameter_count = parseInt(finder.getcount('parameters'));
                                    for(var o=0;o<parameter_count;o++)
                                    {
                                        finder.goto("parameters", o);                                        
                                        nametoid[finder.get('name')]=deep_devices_id;
                                        //apply_rules(finder.get('name'));
                                        finder.id = deep_devices_id;
                                    }
                                    finder.id = deep_chains_id;
                                }
                            }
                            finder.id = devices_id;
                        }
                    }
                    */
                    finder.id = chains_id;
                }
            }
            finder.id = target_id;
        }
    }
}


function printnames(){
    for(i in Devices){
        post("\n-----",i);
        for(j in Devices[i]){
            post("\n",j,"_",Devices[i][j]);
        }
    }
}



/*
Appendix 01: Desired Parameters for each Device Class

-----  InstrumentGroupDevice 
1  _  Filter Cutoff 
2  _  Filter Reso 
3  _  Vibrato/ LFO Amt 
4  _  LFO Rate 
5  _  Envelope Attack 
6  _  Chorus Amount 
-----  DrumGroupDevice 
1  _  Macro 1 
2  _  Macro 2 
3  _  Macro 3 
4  _  Macro 4 
5  _  Macro 5 
6  _  Macro 6 
-----  Operator 
20  _  Osc-A Level  
47  _  Osc-B Level 
74  _  Osc-C Level 
101  _  Osc-D Level 
2  _  Transpose 
167  _  Filter Freq
-----  UltraAnalog 
80  _  AEG1 Attack 
81  _  AEG1 Decay 
83  _  AEG1 Sustain 
85  _  AEG1 Rel 
32  _  OSC1 Semi 
48  _  F1 Freq 
-----  OriginalSimpler 
26  _  Ve Attack 
27  _  Ve Decay 
28  _  Ve Sustain 
29  _  Ve Release 
11  _  Transpose 
32  _  Filter Freq 
-----  MultiSampler 
59  _  Ve Attack 
62  _  Ve Decay 
65  _  Ve Sustain 
66  _  Ve Release 
34  _  Transpose 
74  _  Filter Freq 
-----  LoungeLizard 
10  _  M Force 
17  _  F Release 
22  _  F Tone Decay 
23  _  F Tone Vol 
4  _  Semitone
25  _  P Distance 
-----  StringStudio 
24  _  E Pos 
34  _  Exc Force 
37  _  Exc Friction 
40  _  Exc Velocity 
4  _  Semitone 
76  _  Filter Freq 
-----  Collision 
27  _  Noise Attack 
28  _  Noise Decay 
29  _  Noise Sustain 
30  _  Noise Release 
34  _  Res 1 Tune
51  _  Res 1 Brightness 
-----  InstrumentImpulse 
4  _  1 Start 
18  _  1 Envelope Decay 
9  _  1 Stretch Factor 
2  _  Global Time 
3  _  Global Transpose 
13  _  1 Filter Freq
*/